# $Id: time2gps_closest.py 51 2005-03-15 01:08:44Z jcea $

import sys,os,stat,time

if len(sys.argv) !=2 :
  print "Uso: %s directorio <GPS" %sys.argv[0]
  sys.exit(1)

path=sys.argv[1]

if not os.path.isdir(path) :
  print "El parametro DEBE ser un directorio"
  sys.exit(2)

ficheros=[]
for i in os.walk(path) :
  path=i[0]
  for j in i[2] :
    p=path+os.sep+j
    ficheros.append((os.stat(p)[stat.ST_MTIME],p))

  ficheros.sort()
  if time.gmtime(ficheros[0][0])[:3]!=time.gmtime(ficheros[-1][0])[:3] :
    print "Los ficheros a procesar deben corresponderse al mismo dia"
    sys.exit(3)

ftime,path=ficheros.pop(0)
ftime=time.gmtime(ftime)
ftime=3600*ftime[3]+60*ftime[4]+ftime[5]
distancia=sys.maxint
last_time=-sys.maxint
t=0

for i in sys.stdin :
  try :
    j=i.split(",")
    if j[0]!="$GPGGA" : continue
    if j[6]!="1" : continue
    k=j[1]
    t2=t
    t=3600*int(k[0:2])+60*int(k[2:4])+float(k[4:])
    if t<=last_time :
      print "El fichero GPS de entrada debe tener tiempos monotonos crecientes"
      sys.exit(4)
    last_time=t

    d=abs(ftime-t)
    if distancia<d :
      while distancia<d :
        print path,lat,long,distancia
        flag=len(ficheros)==0
        if flag : break
        ftime,path=ficheros.pop(0)
        ftime=time.gmtime(ftime)
        ftime=3600*ftime[3]+60*ftime[4]+ftime[5]
        distancia=abs(ftime-t2)
        d=abs(ftime-t)
      if flag : break

    distancia=d
    lat=float(j[2])
    long=float(j[4])
    if j[3]!="N" : lat=-lat
    if j[5]!="E" : long=-long
  except :
    print >>sys.stderr,i
    raise

